## $Id: test_contract.py 14181 2016-09-23 05:54:20Z henrik $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""
Tests for contracts.
"""
import tempfile
import shutil
from zope.interface.verify import verifyClass, verifyObject
from zope.component import createObject
from zope.component.hooks import setSite
from zope.interface import verify
from waeup.ikoba.customers.interfaces import ICustomerNavigation
from waeup.ikoba.customers.contracts import ContractsContainer

from ikobacustom.uniben.testing import (FunctionalLayer, FunctionalTestCase)
from ikobacustom.uniben.customers.contracts import UnibenContract
from ikobacustom.uniben.customers.interfaces import IUnibenContract


class ContractsContainerTestCase(FunctionalTestCase):

    layer = FunctionalLayer

    def test_interfaces(self):
        verify.verifyClass(IUnibenContract, UnibenContract)
        verify.verifyClass(ICustomerNavigation, UnibenContract)
        verify.verifyObject(IUnibenContract, UnibenContract())
        verify.verifyObject(ICustomerNavigation, UnibenContract())
        return

    def test_addContract(self):
        container = ContractsContainer()
        contract = createObject(u'waeup.UnibenContract')
        id = contract.contract_id
        container.addContract(contract)
        self.assertEqual(container[id], contract)
        self.assertRaises(TypeError, container.addContract, object())
        self.assertEqual(contract.class_name, 'UnibenContract')
        return
